<template>
  <div>
    <div class="flex flex-no-wrap bg-gray-200 text-white h-screen">
      <div
        class="w-64 absolute sm:relative bg-gray-800 shadow md:h-auto flex-col justify-between hidden sm:flex"
      >
        <Sidebar />
      </div>

      <div class="container mx-auto py-10 h-auto md:w-4/5 w-11/12 px-6">
        <div class="flex flex-col">
          <div class="-my-2 overflow-x-auto sm:-mx-6 lg:-mx-8">
            <div
              class="py-2 align-middle inline-block min-w-full sm:px-6 lg:px-8"
            >
              <div
                class="shadow overflow-hidden border-b border-gray-200 sm:rounded-lg"
              >
                <table class="min-w-full divide-y divide-gray-200">
                  <thead class="bg-gray-50">
                    <tr>
                      <th
                        scope="col"
                        class="px-6 py-3 text-left text-xs font-medium text-gray-500 uppercase tracking-wider"
                      >
                        Jeu
                      </th>
                      <th
                        scope="col"
                        class="px-6 py-3 text-left text-xs font-medium text-gray-500 uppercase tracking-wider"
                      >
                        Studio
                      </th>
                      <th
                        scope="col"
                        class="relative px-6 py-3 text-xs font-medium text-gray-500 uppercase"
                      >
                        <span>Actions</span>
                      </th>
                    </tr>
                  </thead>
                  <tbody class="bg-white divide-y divide-gray-200">
                    <tr v-for="(game, key) in games" :key="`${key}`">
                      <td class="px-6 py-4 whitespace-nowrap">
                        <div class="text-sm text-gray-900">{{ game.game.name }}</div>
                      </td>
                      <td class="px-6 py-4 whitespace-nowrap">
                        <div class="text-sm text-gray-900">
                          {{ game.claimer.name }}
                        </div>
                      </td>
                      <td
                        class="px-6 py-4 whitespace-nowrap text-center text-sm font-medium"
                      >
                        <div class="flex gap-4 justify-center">
                          <a
                            @click="acceptRequest(game.id, key)"
                            class="text-indigo-600 hover:text-indigo-900 cursor-pointer"
                            >Attribuer</a
                          >
                          <a
                            @click="refuseRequest(game.id, key)"
                            class="text-indigo-600 hover:text-indigo-900 cursor-pointer"
                            >Refuser</a
                          >
                        </div>
                      </td>
                    </tr>
                  </tbody>
                </table>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import Sidebar from "./Sidebar"

export default {
  name: "Game",
  components: {
    Sidebar
  },
  data() {
    return {
      games: [],
      urlGetGamesClaim: `https://${window.location.hostname}:8443/game_claims`
    }
  },
  inject: ["createAlert", "user"],
  beforeMount() {
    const headers = {
      Accept: "application/json",
      "Content-Type": "application/json",
      Authorization: "Bearer " + this.user.token
    }

    fetch(this.urlGetGamesClaim, {
      headers,
      method: "GET"
    })
      .then((res) => {
        if (res.ok) {
          return res.json()
        } else {
          throw new Error("Something went wrong")
        }
      })
      .then((data) => {
        if (data) {
          this.games = data
        } else {
          this.createAlert({
            color: "red",
            text: "Une erreur est survenue",
            icon: "times"
          })
        }
      })
      .catch(() => {
        this.createAlert({
          color: "red",
          text: "Une erreur est survenue",
          icon: "times"
        })
      })
  },
	  methods: {
    acceptRequest: function(id, key) {
      const headers = {
            Accept: "application/json",
            "Content-Type": "application/json",
            Authorization: "Bearer " + this.user.token
          }

      fetch(this.urlGetGamesClaim + "/" + id + "/accept", {
        headers,
        method: "GET"
      })
        .then((res) => {
          if (res.ok) {
						this.createAlert({
            color: "green",
            text: "Le jeu" + this.games[key].game.name + " a été attribué à" + this.games[key].claimer.name,
            icon: "check"
          })
            this.games.splice(key, 1)
          } else {
            throw new Error("Something went wrong")
          }
        })
        .catch(() => {
          this.createAlert({
            color: "red",
            text: "Une erreur est survenue",
            icon: "times"
          })
        })
    },
    refuseRequest: function(id, key) {
      const headers = {
            Accept: "application/json",
            "Content-Type": "application/json",
            Authorization: "Bearer " + this.user.token
          }

      fetch(this.urlGetGamesClaim + "/" + id, {
        headers,
        method: "DELETE"
      })
        .then((res) => {
          if (res.ok) {
            this.games.splice(key, 1)
          } else {
            throw new Error("Something went wrong")
          }
        })
        .catch(() => {
          this.createAlert({
            color: "red",
            text: "Une erreur est survenue",
            icon: "times"
          })
        })
    }
  }
}
</script>

<style scoped>
.is-visible {
  display: block;
}
</style>
